on swapCast spriteNumber, castMember
  set the castNum of sprite spriteNumber to member castMember
  set the visible of sprite spriteNumber to 1
  updateStage()
end

on setButtonChosen whichButton
  global TheirAnswer
  if TheirAnswer <> 0 then
    if TheirAnswer = whichButton then
      swapCast(whichButton + 15, "ButtNorm")
      swapCast(30, "DoneNoSparkle")
      set TheirAnswer to 0
    end if
  else
    set TheirAnswer to whichButton
    repeat with buttonNum = 1 to 4
      if buttonNum = TheirAnswer then
        swapCast(buttonNum + 15, "yellow button")
        next repeat
      end if
      swapCast(buttonNum + 15, "ButtNorm")
    end repeat
    swapCast(30, "DoneSparkle")
    updateStage()
  end if
end

on setButtonChosenFor2Choices whichButton
  global TheirAnswer1, TheirAnswer2, MultipleChoicesClicked
  if whichButton = TheirAnswer1 then
    swapCast(whichButton + 15, "ButtNorm")
    swapCast(30, "DoneNoSparkle")
    set MultipleChoicesClicked to MultipleChoicesClicked - 1
    set TheirAnswer1 to 0
    exit
  end if
  if whichButton = TheirAnswer2 then
    swapCast(whichButton + 15, "ButtNorm")
    swapCast(30, "DoneNoSparkle")
    set MultipleChoicesClicked to MultipleChoicesClicked - 1
    set TheirAnswer2 to 0
    exit
  end if
  if MultipleChoicesClicked = 2 then
    exit
  end if
  set MultipleChoicesClicked to MultipleChoicesClicked + 1
  case MultipleChoicesClicked of
    1:
      set TheirAnswer1 to whichButton
    2:
      if TheirAnswer2 = 0 then
        set TheirAnswer2 to whichButton
      else
        set TheirAnswer1 to whichButton
      end if
  end case
  swapCast(whichButton + 15, "yellow button")
  updateStage()
  if MultipleChoicesClicked = 2 then
    CreateTwoDigitAnswer(TheirAnswer1, TheirAnswer2)
    swapCast(30, "DoneSparkle")
  end if
end

on CreateTwoDigitAnswer TheirAnswer1, TheirAnswer2
  global TheirAnswer
  if TheirAnswer1 > TheirAnswer2 then
    set temp to TheirAnswer2
    set TheirAnswer2 to TheirAnswer1
    set TheirAnswer1 to temp
  end if
  set TheirAnswer to (10 * TheirAnswer1) + TheirAnswer2
end

on RollOverStatesTwoChoices
  global TheirAnswer1, TheirAnswer2, MultipleChoicesClicked
  repeat with counter = 16 to 20
    if (counter = (TheirAnswer1 + 15)) or (counter = (TheirAnswer2 + 15)) then
      nothing()
      next repeat
    end if
    if rollOver(counter) then
      swapCast(counter, "yellow button")
      next repeat
    end if
    swapCast(counter, "ButtNorm")
  end repeat
end

on RollOverStates
  global TheirAnswer
  repeat with counter = 16 to 19
    if counter = (TheirAnswer + 15) then
      nothing()
      next repeat
    end if
    if rollOver(counter) then
      swapCast(counter, "yellow button")
      next repeat
    end if
    swapCast(counter, "ButtNorm")
  end repeat
end

on resetQuestion
  global TheirAnswer, Answering
  swapCast(7, "done_button")
  if TheirAnswer <> 0 then
    swapCast(TheirAnswer + 7, "ButtNorm")
  end if
  swapCast(12, "question")
  swapCast(5, "blank")
  set TheirAnswer to 0
  set Answering to 1
  updateStage()
end

on endOfQuestion
  global doneFlag, trynumber
  set doneFlag to 1
  addAt(studentRecord, 10, trynumber)
end

on PlaySound soundtype
  global gSoundFlag
  if gSoundFlag = "Y" then
    case soundtype of
      1:
        puppetSound(1, "correct sound")
      2:
        puppetSound(1, "flashlight sound")
      3:
      4:
        puppetSound(1, "button sound")
      5:
        puppetSound(1, "400501.aif")
      6:
        puppetSound(1, "194200.aif")
    end case
    updateStage()
  end if
end

on MemorySetup StartCast, EndCast, LoadFlag
  if LoadFlag = 1 then
    preloadMember(StartCast, EndCast)
  else
    unloadMember(StartCast, EndCast)
  end if
end

on IntializePopUpWinOnMovieStart
  global gintPopUpWinType, gintPopUpChannel
  set gintPopUpChannel to 44
  set gintPopUpWinType to 0
  repeat with loop1 = 0 to 4
    set the visible of sprite (gintPopUpChannel + loop1) to 0
  end repeat
end

on GSBMenuButtonScript
  global gIntSkill, gintPopUpWinType, gBookMark, gMovie1, gMovie2
  puppetSprite(28, 0)
  updateStage()
  set gIntSkill to the clickOn - 6
  cursor(4)
  setCastIndex()
  setScores()
  case gIntSkill of
    0:
      go(1, "GSB_GT.dxr")
    1, 2, 5, 6, 7, 8:
      repeat with counter = 6 to 19
        puppetSprite(counter, 0)
        set the visible of sprite counter to 0
      end repeat
      if gMovie1 = 0 then
        set gMovie1 to 1
        set gMovie2 to 0
        go("Start")
      else
        go("Menu")
      end if
    3, 4, 9, 10, 11, 12, 13:
      updateStage()
      unloadMember()
      go("Start", "GSBMain2.dxr")
  end case
end

on SubMenuButtonScript
  global gCharSection, gIntSkill, gGPPageNumber, gSubMenuCase, GPScoreList, GPNumQuesList, gBookMarkUsed, gSkillLoadOffset, gContentPageNum, gOvStart, gGP1Start, gRvStart, gAp1Start, gAp2Start, gBookMark
  case gSubMenuCase of
    6:
      set gBookMarkUsed to 1
      repeat with counter = 6 to 9
        puppetSprite(counter, 0)
      end repeat
      puppetSprite(40, 0)
      set StartCast to gOvStart
      set EndCast to gOvStart + 30
      set LoadFlag to 1
      MemorySetup(StartCast, EndCast, LoadFlag)
      set gCharSection to "O"
      set destination to gIntSkill & "o1"
      go(destination)
    7:
      repeat with counter = 6 to 9
        puppetSprite(counter, 0)
      end repeat
      puppetSprite(40, 0)
      set StartCast to gGP1Start
      set EndCast to gGP1Start + 60
      set LoadFlag to 1
      MemorySetup(StartCast, EndCast, LoadFlag)
      set gCharSection to "G"
      if (gGPPageNumber <> EMPTY) and (gBookMarkUsed = 0) then
        set gBookMark to EMPTY
        set gBookMarkUsed to 1
        set GPScoreList to []
        repeat with counter = 1 to getAt(gGPNumQuesList, gIntSkill)
          setAt(GPScoreList, counter, 10)
        end repeat
        set gContentPageNum to gGPPageNumber
        set destination to gIntSkill & "g" & gGPPageNumber
      else
        set destination to gIntSkill & "g1"
      end if
      go(destination)
    8:
      set gBookMarkUsed to 1
      repeat with counter = 6 to 9
        puppetSprite(counter, 0)
      end repeat
      puppetSprite(40, 0)
      set StartCast to gRvStart
      set EndCast to gRvStart + 20
      set LoadFlag to 1
      MemorySetup(StartCast, EndCast, LoadFlag)
      set gCharSection to "R"
      set destination to gIntSkill & "r"
      go(destination)
    9:
      if gBookMark <> EMPTY then
        set gBookMarkUsed to 1
        set destination to gIntSkill & "a1"
        go(destination)
      else
        preloadMember("AppOKDown")
        preloadMember("AppCancelDown")
        PopUpWinCall(9, "Y", "xxx")
      end if
  end case
end

on ClearQuestionPanel
  global QuestionNum, TheirAnswer, gCharLang, gCharSection
  puppetSprite(13, 0)
  puppetSprite(15, 0)
  set the visible of sprite 37 to 0
  set the visible of sprite 33 to 0
  swapCast(38, "question.bar")
  set TheirAnswer to 0
end

on ResetQuestionPanelMultChoice
  global QuestionNum, TheirAnswer, TheirAnswer1, TheirAnswer2, MultipleChoicesClicked, gIntType
  if gIntType = 2 then
    repeat with counter = 16 to 19
      swapCast(counter, "ButtNorm")
    end repeat
  else
    repeat with counter = 16 to 20
      swapCast(counter, "ButtNorm")
    end repeat
  end if
  set the visible of sprite 37 to 0
  swapCast(38, "question.bar")
  swapCast(30, "DoneNoSparkle")
  set TheirAnswer to 0
  set TheirAnswer1 to 0
  set TheirAnswer2 to 0
  set MultipleChoicesClicked to 0
end

on ClearQuestionPanelMultChoice
  global QuestionNum, TheirAnswer, TheirAnswer1, TheirAnswer2, MultipleChoicesClicked, gIntType
  puppetSprite(15, 0)
  if gIntType = 0 then
    nothing()
  else
    set the visible of sprite 37 to 0
    puppetSprite(37, 0)
    swapCast(38, "question.bar")
    puppetSprite(15, 0)
    if gIntType = 2 then
      repeat with counter = 16 to 19
        swapCast(counter, "ButtNorm")
        puppetSprite(counter, 0)
      end repeat
    else
      if gIntType = 3 then
        repeat with counter = 16 to 20
          swapCast(counter, "ButtNorm")
          puppetSprite(counter, 0)
        end repeat
      end if
    end if
  end if
  set TheirAnswer to 0
  set TheirAnswer1 to 0
  set TheirAnswer2 to 0
  set MultipleChoicesClicked to 0
end

on EvenOddTest TheirAnswer
  global IsItODD, type
  set y to integer(TheirAnswer / 2) * 10
  set x to TheirAnswer * 10 / 2
  if y = x then
    set IsItODD to 0
    exit
  else
    set IsItODD to 1
    swapCast(33, "Ybar" & TheirAnswer)
    set the visible of sprite 33 to 1
    updateStage()
  end if
end

on MenuNavClicked whichmenu
  global gCharSection, gIntSkill, gLogonCount, gGPAttempts, gSkillLoadOffset, gAp1Start, gGP1Start, gSkillLoadEnd, gRvStart
  if whichmenu = "GSB" then
    puppetSprite(40, 0)
  end if
  updateStage()
  case whichmenu of
    "GSB":
      repeat with counter = 4 to 43
        set the visible of sprite counter to 0
      end repeat
      repeat with counter = 4 to 43
        puppetSprite(counter, 0)
      end repeat
      if gLogonCount <> 0 then
        if gGPAttempts <> 0 then
          updateRoster()
        end if
      end if
      unloadMember(gSkillLoadOffset, gSkillLoadEnd)
      go("MM")
    "SkillMenu":
      repeat with counter = 5 to 43
        set the visible of sprite counter to 0
      end repeat
      repeat with counter = 5 to 43
        puppetSprite(counter, 0)
      end repeat
      if gCharSection = "A" then
        unloadMember(gAp1Start, gSkillLoadEnd)
      else
        if gCharSection = "G" then
          unloadMember(gGP1Start, gRvStart)
        end if
      end if
      go("Menu")
  end case
end

on WhereIsRight
  global gContentPageNum, gCharSection
  updateStage()
  if gContentPageNum = 1 then
    set the visible of sprite 35 to 0
  end if
  set the castNum of sprite 30 to cast "BarrowSparkle"
  repeat while the mouseDown
    nothing()
  end repeat
  set gContentPageNum to gContentPageNum + 1
  go(the frame + 1)
end

on WhereIsLeft
  global gContentPageNum, gCharSection
  if gContentPageNum > 1 then
    set gContentPageNum to gContentPageNum - 1
    set the castNum of sprite 30 to member "LeftArrow"
    updateStage()
    if gContentPageNum = 1 then
      set the castNum of sprite 30 to member "RarrowSparkle"
    else
      set the castNum of sprite 30 to member "BarrowSparkle"
    end if
    updateStage()
    go(marker(-1))
  else
    set the visible of sprite 37 to 0
    go("Menu")
  end if
end

on CheckForLastQuestion
  global QuestionNum, gCharSection
  if (QuestionNum = 6) and (gCharSection = "A") then
    repeat with counter = 30 to 33
      puppetSprite(counter, 0)
    end repeat
    go("menu")
  else
    swapCast(30, "DoneNoSparkle")
  end if
  if (gCharSection = "G") and (QuestionNum = 8) then
    repeat with counter = 30 to 33
      puppetSprite(counter, 0)
    end repeat
    go("menu")
  else
    swapCast(30, "DoneNoSparkle")
  end if
end

on set2choiceIncorrectHilites Credit
  global QuestionNum, gCharSection, TheirAnswer, TheirAnswer1, TheirAnswer2, AppAnswersList, GPAnswersList, AppScoreList, GPScoreList, LangChannel
  case gCharSection of
    "G":
      set TwoDigitAnswer to getAt(GPAnswersList, QuestionNum)
    "A":
      set TwoDigitAnswer to getAt(AppAnswersList, QuestionNum)
  end case
  set firstCorrect to TwoDigitAnswer / 10
  set secondCorrect to TwoDigitAnswer - (firstCorrect * 10)
  set bothwrong to (TheirAnswer1 <> firstCorrect) and (TheirAnswer1 <> secondCorrect) and ((TheirAnswer2 <> firstCorrect) and (TheirAnswer2 <> secondCorrect))
  if Credit = 0 then
    set the castNum of sprite (TheirAnswer1 + 15) to member "red button"
    set the castNum of sprite (TheirAnswer2 + 15) to member "red button"
    swapCast(firstCorrect + 15, "green button")
    swapCast(secondCorrect + 15, "green button")
    swapCast(38, "incorrect.bar")
    exit
  end if
  if bothwrong then
    swapCast(38, "incorrect.bar")
    swapCast(TheirAnswer1 + 15, "red button")
    swapCast(TheirAnswer2 + 15, "red button")
    set the castNum of sprite 37 to the castNum of sprite LangChannel + 2
    set the locV of sprite 37 to the bottom of sprite LangChannel
  else
    swapCast(38, "partcorrect.bar")
    set the castNum of sprite 37 to the castNum of sprite LangChannel + 4
    set the locV of sprite 37 to the bottom of sprite LangChannel
    if (TheirAnswer1 = firstCorrect) or (TheirAnswer1 = secondCorrect) then
      swapCast(TheirAnswer1 + 15, "green button")
      swapCast(TheirAnswer2 + 15, "red button")
    else
      swapCast(TheirAnswer2 + 15, "green button")
      swapCast(TheirAnswer1 + 15, "red button")
    end if
  end if
end

on setCastIndex
  global gIntSkill, gSkillLoadOffset, gSkillLoadEnd, gOvStart, gGP1Start, gGP2Start, gGP3Start, gGP4Start, gRvStart, gAp1Start, gAp2Start
  case gIntSkill of
    1:
      set offset to the number of member "1Start"
      set gSkillLoadOffset to offset
      set gOvStart to the number of member "1OvStart"
      set gGP1Start to the number of member "1GP1Start"
      set gGP2Start to the number of member "1GP2Start"
      set gGP3Start to the number of member "1GP3Start"
      set gGP4Start to the number of member "1GP4Start"
      set gRvStart to the number of member "1RvStart"
      set gAp1Start to the number of member "1Ap1Start"
      set gAp2Start to the number of member "1Ap2Start"
      set gSkillLoadEnd to the number of member "1End"
    2:
      set offset to the number of member "2Start"
      set gSkillLoadOffset to offset
      set gOvStart to the number of member "2OvStart"
      set gGP1Start to the number of member "2GP1Start"
      set gGP2Start to the number of member "2GP2Start"
      set gGP3Start to the number of member "2GP3Start"
      set gGP4Start to the number of member "2GP4Start"
      set gRvStart to the number of member "2RvStart"
      set gAp1Start to the number of member "2Ap1Start"
      set gAp2Start to the number of member "2Ap2Start"
      set gSkillLoadEnd to the number of member "2End"
    5:
      set offset to the number of member "5Start"
      set gSkillLoadOffset to offset
      set gOvStart to the number of member "5OvStart"
      set gGP1Start to the number of member "5GP1Start"
      set gGP2Start to the number of member "5GP2Start"
      set gGP3Start to the number of member "5GP3Start"
      set gGP4Start to the number of member "5GP4Start"
      set gRvStart to the number of member "5RvStart"
      set gAp1Start to the number of member "5Ap1Start"
      set gAp2Start to the number of member "5Ap2Start"
      set gSkillLoadEnd to the number of member "5End"
    6:
      set offset to the number of member "6Start"
      set gSkillLoadOffset to offset
      set gOvStart to the number of member "6OvStart"
      set gGP1Start to the number of member "6GP1Start"
      set gGP2Start to the number of member "6GP2Start"
      set gGP3Start to the number of member "6GP3Start"
      set gGP4Start to the number of member "6GP4Start"
      set gRvStart to the number of member "6RvStart"
      set gAp1Start to the number of member "6Ap1Start"
      set gAp2Start to the number of member "6Ap2Start"
      set gSkillLoadEnd to the number of member "6End"
    7:
      set offset to the number of member "7Start"
      set gSkillLoadOffset to offset
      set gOvStart to the number of member "7OvStart"
      set gGP1Start to the number of member "7GP1Start"
      set gGP2Start to the number of member "7GP2Start"
      set gGP3Start to the number of member "7GP3Start"
      set gGP4Start to the number of member "7GP4Start"
      set gRvStart to the number of member "7RvStart"
      set gAp1Start to the number of member "7Ap1Start"
      set gAp2Start to the number of member "7Ap2Start"
      set gSkillLoadEnd to the number of member "7End"
    8:
      set offset to the number of member "8Start"
      set gSkillLoadOffset to offset
      set gOvStart to the number of member "8OvStart"
      set gGP1Start to the number of member "8GP1Start"
      set gGP2Start to the number of member "8GP2Start"
      set gGP3Start to the number of member "8GP3Start"
      set gGP4Start to the number of member "8GP4Start"
      set gRvStart to the number of member "8RvStart"
      set gAp1Start to the number of member "8Ap1Start"
      set gAp2Start to the number of member "8Ap2Start"
      set gSkillLoadEnd to the number of member "8End"
  end case
end

on setScores
  global gIntSkill, gintPopUpWinType, AppAnswersList, GPAnswersList, AppScoreList, GPScoreList, A1AnswersList, G1AnswersList, A1ScoreList, G1ScoreList, A2AnswersList, G2AnswersList, A2ScoreList, G2ScoreList, A3AnswersList, G3AnswersList, A3ScoreList, G3ScoreList, A4AnswersList, G4AnswersList, A4ScoreList, G4ScoreList, A5AnswersList, G5AnswersList, A5ScoreList, G5ScoreList, A6AnswersList, G6AnswersList, A6ScoreList, G6ScoreList, A7AnswersList, G7AnswersList, A7ScoreList, G7ScoreList, A8AnswersList, G8AnswersList, A8ScoreList, G8ScoreList, A9AnswersList, G9AnswersList, A9ScoreList, G9ScoreList, A10AnswersList, G10AnswersList, A10ScoreList, G10ScoreList, A11AnswersList, G11AnswersList, A11ScoreList, G11ScoreList, A12AnswersList, G12AnswersList, A12ScoreList, G12ScoreList, A13AnswersList, G13AnswersList, A13ScoreList, G13ScoreList
  case gIntSkill of
    1:
      set AppAnswersList to duplicate(A1AnswersList)
      set GPAnswersList to duplicate(G1AnswersList)
      set AppScoreList to duplicate(A1ScoreList)
      set GPScoreList to duplicate(G1ScoreList)
    2:
      set AppAnswersList to duplicate(A2AnswersList)
      set GPAnswersList to duplicate(G2AnswersList)
      set AppScoreList to duplicate(A2ScoreList)
      set GPScoreList to duplicate(G2ScoreList)
    3:
      set AppAnswersList to duplicate(A3AnswersList)
      set GPAnswersList to duplicate(G3AnswersList)
      set AppScoreList to duplicate(A3ScoreList)
      set GPScoreList to duplicate(G3ScoreList)
    4:
      set AppAnswersList to duplicate(A4AnswersList)
      set GPAnswersList to duplicate(G4AnswersList)
      set AppScoreList to duplicate(A4ScoreList)
      set GPScoreList to duplicate(G4ScoreList)
    5:
      set AppAnswersList to duplicate(A5AnswersList)
      set GPAnswersList to duplicate(G5AnswersList)
      set AppScoreList to duplicate(A5ScoreList)
      set GPScoreList to duplicate(G5ScoreList)
    6:
      set AppAnswersList to duplicate(A6AnswersList)
      set GPAnswersList to duplicate(G6AnswersList)
      set AppScoreList to duplicate(A6ScoreList)
      set GPScoreList to duplicate(G6ScoreList)
    7:
      set AppAnswersList to duplicate(A7AnswersList)
      set GPAnswersList to duplicate(G7AnswersList)
      set AppScoreList to duplicate(A7ScoreList)
      set GPScoreList to duplicate(G7ScoreList)
    8:
      set AppAnswersList to duplicate(A8AnswersList)
      set GPAnswersList to duplicate(G8AnswersList)
      set AppScoreList to duplicate(A8ScoreList)
      set GPScoreList to duplicate(G8ScoreList)
    9:
      set AppAnswersList to duplicate(A9AnswersList)
      set GPAnswersList to duplicate(G9AnswersList)
      set AppScoreList to duplicate(A9ScoreList)
      set GPScoreList to duplicate(G9ScoreList)
    10:
      set AppAnswersList to duplicate(A10AnswersList)
      set GPAnswersList to duplicate(G10AnswersList)
      set AppScoreList to duplicate(A10ScoreList)
      set GPScoreList to duplicate(G10ScoreList)
    11:
      set AppAnswersList to duplicate(A11AnswersList)
      set GPAnswersList to duplicate(G11AnswersList)
      set AppScoreList to duplicate(A11ScoreList)
      set GPScoreList to duplicate(G11ScoreList)
    12:
      set AppAnswersList to duplicate(A12AnswersList)
      set GPAnswersList to duplicate(G12AnswersList)
      set AppScoreList to duplicate(A12ScoreList)
      set GPScoreList to duplicate(G12ScoreList)
    13:
      set AppAnswersList to duplicate(A13AnswersList)
      set GPAnswersList to duplicate(G13AnswersList)
      set AppScoreList to duplicate(A13ScoreList)
      set GPScoreList to duplicate(G13ScoreList)
  end case
end

on InitSections
  global g1SectionList, g2SectionList, g3SectionList, g4SectionList, g5SectionList, g6SectionList, g7SectionList, g8SectionList, g12SectionList, g13SectionList, g9SectionList, g10SectionList, g11SectionList
  set g1SectionList to list(0, 0, 0, 0)
  set g2SectionList to list(0, 0, 0, 0)
  set g3SectionList to list(0, 0, 0, 0)
  set g4SectionList to list(0, 0, 0, 0)
  set g5SectionList to list(0, 0, 0, 0)
  set g6SectionList to list(0, 0, 0, 0)
  set g7SectionList to list(0, 0, 0, 0)
  set g8SectionList to list(0, 0, 0, 0)
  set g9SectionList to list(0, 0, 0, 0)
  set g10SectionList to list(0, 0, 0, 0)
  set g11SectionList to list(0, 0, 0, 0)
  set g12SectionList to list(0, 0, 0, 0)
  set g13SectionList to list(0, 0, 0, 0)
end
